require "protonet/hardware/version"
require "protonet/hardware/storage"

require "json"

module Protonet
  module Hardware
    class << self
      def storages
        bus["children"].select do |child|
          child["class"] == "storage"
        end.map do |child|
          Storage.new child
        end
      end

      def bus
        fetch["children"].select do |child|
          child["class"] == "bus"
        end.first # there is only one bus at a time
      end

      def detect
        @fetch = JSON.parse `sudo -n #{lshw} -json`
      end

      private
        def fetch
          @fetch ||= detect
        end

        def lshw
          @lshw ||= begin
            lshw_path = `which lshw`.strip
            unless $?.success?
              ENV["DEVELOPMENT"] = "true"
              lshw_path = File.expand_path('../../../test/bin/lshw', __FILE__)
            end
            lshw_path
          end
        end
    end
  end
end
