require 'protonet/hardware/volume'

module Protonet::Hardware
  class Disk
    def initialize(attributes = {})
      @attributes = attributes
    end

    AVAILABLE_ATTRIBUTES =[:id, :claimed, :handle, :description, :product, :vendor, :physid, :businfo, :logicalname, :dev, :version, :serial, :units, :size]

    AVAILABLE_ATTRIBUTES.each do |method|
      define_method method do
        @attributes[method.to_s]
      end
    end

    def volumes
      (@attributes["children"] || []).map do |child|
        Volume.new child
      end
    end

    def to_json(*generator_state)
      (AVAILABLE_ATTRIBUTES << :volumes).inject({}) do |accu, element|
        accu[element] = self.send(element)
        accu
      end.to_json(*generator_state)
    end
  end
end
