require 'protonet/hardware/disk'

module Protonet::Hardware
  class Storage
    def initialize(attributes = {})
      @attributes = attributes
    end

    AVAILABLE_ATTRIBUTES = [:id, :claimed, :handle, :physid, :businfo, :logicalname]

    AVAILABLE_ATTRIBUTES.each do |method|
      define_method method do
        @attributes[method.to_s]
      end
    end

    def disks
      (@attributes["children"] || []).map do |child|
        Disk.new child
      end
    end

    def usb?
      businfo =~ /usb/
    end

    def to_json(*generator_state)
      (AVAILABLE_ATTRIBUTES << :disks << :usb?).inject({}) do |accu, element|
        accu[element] = self.send(element)
        accu
      end.to_json(*generator_state)
    end
  end
end
