module Protonet::Hardware
  class Volume
    def initialize(attributes = {})
      @attributes = attributes
    end

    AVAILABLE_ATTRIBUTES = [:id, :claimed, :handle, :description, :physid, :businfo, :logicalname, :dev, :serial, :size, :capacity]

    AVAILABLE_ATTRIBUTES.each do |method|
      define_method method do
        @attributes[method.to_s]
      end
    end

    def label
      (@attributes["configuration"] || {})["label"] || nil
    end

    def to_json(*generator_state)
      (AVAILABLE_ATTRIBUTES << :label).inject({}) do |accu, element|
        accu[element] = self.send(element)
        accu
      end.to_json(*generator_state)
    end
  end
end

