require 'minitest_helper'

module TestProtonet
  module Hardware
    class DiskTest < Minitest::Test
      def test_empty_volumes
        assert_equal empty_disk.volumes, []
      end

      def test_disk_with_volumes
        n = 10
        disk = disk_with_volumes(n)
        assert_equal n, disk.volumes.size
        disk.volumes.each do |volume|
          assert_instance_of ::Protonet::Hardware::Volume, volume
        end
      end

      private
        def empty_disk
          ::Protonet::Hardware::Disk.new
        end

        def disk_with_volumes(n)
          ::Protonet::Hardware::Disk.new({ "children" => [{}] * n })
        end
    end
  end
end
